Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs	(revision 4423)
@@ -62,5 +62,5 @@
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
     public ResponseHeartBeat ProcessHeartBeat(HeartBeatData hbData) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) { // due to concurrency issues with lifecycle-heartbeat do the transaction inside
         return slaveCommunicator.ProcessHeartBeat(hbData);
       }
@@ -77,8 +77,8 @@
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
-    public ResponseResultReceived StoreFinishedJobResult(Guid slaveId, Guid jobId, byte[] result, double percentage, string exception) {
-      using (contextFactory.GetContext()) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
-        return slaveCommunicator.StoreFinishedJobResult(slaveId, jobId, result, percentage, exception);
+    public ResponseResultReceived StoreFinishedJobResult(Guid slaveId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
+      using (contextFactory.GetContext()) {
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobId);
+        return slaveCommunicator.StoreFinishedJobResult(slaveId, jobId, result, executionTime, exception);
       }
     }
@@ -108,8 +108,8 @@
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
-    public ResponseResultReceived ProcessSnapshot(Guid slaveId, Guid jobId, byte[] result, double percentage, string exception) {
-      using (contextFactory.GetContext()) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
-        return slaveCommunicator.ProcessSnapshot(slaveId, jobId, result, percentage, exception);
+    public ResponseResultReceived ProcessSnapshot(Guid slaveId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
+      using (contextFactory.GetContext()) {
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobId);
+        return slaveCommunicator.ProcessSnapshot(slaveId, jobId, result, executionTime, exception);
       }
     }
@@ -136,5 +136,4 @@
       using (contextFactory.GetContext()) {
         return jobManager.AddChildJob(parentJobId, serializedJob);
-        
       }
     }
@@ -149,4 +148,5 @@
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
     public Stream GetStreamedJob(Guid slaveId) {
+      ServiceLocator.GetLifecycleManager().JobsCurrentlyTransferring++;
       using (contextFactory.GetContext(false)) {
         ResponseObject<JobDto> job = null;
@@ -170,4 +170,5 @@
             stream.Dispose();
           }
+          ServiceLocator.GetLifecycleManager().JobsCurrentlyTransferring--;
         });
 
@@ -221,4 +222,13 @@
       }
     }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
+    public Response DeleteChildJobs(Guid jobId) {
+      using (contextFactory.GetContext()) {
+        return jobManager.DeleteChildJobs(jobId);
+      }
+    }
+
     #endregion
   }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/InternalInterfaces/IAuthorizationManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/InternalInterfaces/IAuthorizationManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/InternalInterfaces/IAuthorizationManager.cs	(revision 4423)
@@ -3,5 +3,7 @@
 namespace HeuristicLab.Hive.Server.Core.InternalInterfaces {
   public interface IAuthorizationManager {
-
+    /// <summary>
+    /// Returns the UserId of the currently authenticated user
+    /// </summary>
     Guid UserId { get; }
 
@@ -11,5 +13,10 @@
     /// </summary>
     /// <exception cref="SecurityException">thrown when access denied</exception>
-    void AuthorizeForJobs(params Guid[] jobId);
+    void AuthorizeJobs(params Guid[] jobId);
+
+    /// <summary>
+    /// Compares the current UserId with the given userId and takes appropriate actions if the mismatch
+    /// </summary>
+    void Authorize(Guid userId);
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4423)
@@ -50,6 +50,6 @@
       lifecycleManager = ServiceLocator.GetLifecycleManager();
 
-      lifecycleManager.RegisterStartup(new EventHandler(lifecycleManager_OnStartup));
-      lifecycleManager.RegisterShutdown(new EventHandler(lifecycleManager_OnShutdown));
+      lifecycleManager.Started += new EventHandler(lifecycleManager_Started);
+      lifecycleManager.Stopped += new EventHandler(lifecycleManager_Stopped);
     }
 
@@ -59,5 +59,9 @@
       List<JobDto> allJobs = new List<JobDto>(DaoLocator.JobDao.FindAll());
       foreach (JobDto curJob in allJobs) {
-        if (curJob.State != JobState.Calculating && curJob.State != JobState.Finished) {
+        if (curJob.State != JobState.Calculating &&
+            curJob.State != JobState.Finished &&
+            curJob.State != JobState.Aborted &&
+            curJob.State != JobState.Failed &&
+            curJob.State != JobState.WaitForChildJobs) {
           DaoLocator.JobDao.SetJobOffline(curJob);
         }
@@ -65,5 +69,5 @@
     }
 
-    private void lifecycleManager_OnStartup(object sender, EventArgs e) {
+    private void lifecycleManager_Started(object sender, EventArgs e) {
       Logger.Info("Startup Event Fired, Checking DB for consistency");
       CheckForDeadJobs();
@@ -71,5 +75,5 @@
     }
 
-    private void lifecycleManager_OnShutdown(object sender, EventArgs e) {
+    private void lifecycleManager_Stopped(object sender, EventArgs e) {
       Logger.Info("Startup Event Fired, Checking DB for consistency");
       CheckForDeadJobs();
@@ -155,6 +159,7 @@
 
       if (job != null && job.JobInfo != null) {
-        if (job.JobInfo.State != JobState.Offline) {
-          response.StatusMessage = ResponseStatus.AddNewJob_JobStateMustBeOffline;
+        // only Offline and WaitForChildJobs are allowed
+        if (job.JobInfo.State != JobState.Offline && job.JobInfo.State != JobState.WaitForChildJobs) {
+          response.StatusMessage = ResponseStatus.AddNewJob_InvalidJobState;
           return response;
         }
@@ -228,5 +233,9 @@
       response.Obj.JobInfo = job;
 
-      response.Obj.SerializedJobData = DaoLocator.JobDao.GetBinaryJobFile(jobId);
+      if (job != null) {
+        response.Obj.SerializedJobData = DaoLocator.JobDao.GetBinaryJobFile(jobId);
+      } else {
+        response.StatusMessage = ResponseStatus.GetLastSerializedResult_JobDoesNotExist;
+      }
 
       return response;
@@ -285,9 +294,4 @@
         //response.Success = true;
         response.StatusMessage = ResponseStatus.AbortJob_AbortAlreadyRequested;
-        return response; // no commit needed
-      }
-      if (job.State != JobState.Calculating && job.State != JobState.SnapshotRequested && job.State != JobState.SnapshotSent) {
-        //response.Success = false;
-        response.StatusMessage = ResponseStatus.AbortJob_JobIsNotBeeingCalculated;
         return response; // no commit needed
       }
@@ -315,5 +319,5 @@
           DateFinished = job.DateFinished,
           Exception = job.Exception,
-          Percentage = job.Percentage
+          ExecutionTime = job.ExecutionTime
         });
       }
@@ -352,10 +356,10 @@
             DateFinished = job.DateFinished,
             Exception = job.Exception,
-            Percentage = job.Percentage,
-            ParentJobId = job.ParentJob != null ? new Nullable<Guid>(job.ParentJob.Id) : null
+            ExecutionTime = job.ExecutionTime,
+            ParentJobId = job.ParentJobId
           });
         }
       }
-      
+
       response.Obj = jobResultList;
       return response;
@@ -365,5 +369,5 @@
       JobDto parentJob = DaoLocator.JobDao.FindById(parentJobId);
 
-      serializedJob.JobInfo.ParentJob = parentJob;
+      serializedJob.JobInfo.ParentJobId = parentJob.Id;
       serializedJob.JobInfo.UserId = parentJob.UserId;
       serializedJob.JobInfo.AssignedResourceIds = parentJob.AssignedResourceIds;
@@ -376,6 +380,5 @@
 
       jobDto.State = serializedJob.JobInfo.State;
-      jobDto.Percentage = serializedJob.JobInfo.Percentage;
-      
+      jobDto.ExecutionTime = serializedJob.JobInfo.ExecutionTime;
 
       DaoLocator.JobDao.SetBinaryJobFile(serializedJob.JobInfo.Id, serializedJob.SerializedJobData);
@@ -390,4 +393,50 @@
     }
 
+
+    public ResponseObject<HiveExperimentDtoList> GetHiveExperiments() {
+      ResponseObject<HiveExperimentDtoList> response = new ResponseObject<HiveExperimentDtoList>();
+      IEnumerable<HiveExperimentDto> hiveExperiments = DaoLocator.HiveExperimentDao.FindAllByUserId(ServiceLocator.GetAuthorizationManager().UserId);
+      response.Obj = new HiveExperimentDtoList(hiveExperiments);
+      response.StatusMessage = ResponseStatus.Ok;
+      return response;
+    }
+
+    public ResponseObject<HiveExperimentDto> UpdateHiveExperiment(HiveExperimentDto hiveExperimentDto) {
+      ResponseObject<HiveExperimentDto> response = new ResponseObject<HiveExperimentDto>();
+      if (hiveExperimentDto.Id == Guid.Empty) {
+        response.Obj = DaoLocator.HiveExperimentDao.Insert(hiveExperimentDto);
+      } else {
+        DaoLocator.HiveExperimentDao.Update(hiveExperimentDto);
+        response.Obj = hiveExperimentDto;
+      }
+      response.StatusMessage = ResponseStatus.Ok;
+      return response;
+    }
+
+    public Response DeleteHiveExperiment(Guid hiveExperimentId) {
+      Response response = new Response();
+      try {
+        DaoLocator.HiveExperimentDao.Delete(hiveExperimentId);
+      }
+      catch (Exception) {
+        response.StatusMessage = ResponseStatus.DeleteHiveExperiment_Failed;
+      }
+      return response;
+    }
+
+    public Response DeleteChildJobs(Guid jobId) {
+      Response response = new Response();
+      try {
+        IEnumerable<JobDto> childs = DaoLocator.JobDao.FindJobsByParentId(jobId, true);
+        foreach (JobDto childJob in childs) {
+          DaoLocator.JobDao.Delete(childJob.Id);
+        }
+      }
+      catch (Exception) {
+        response.StatusMessage = ResponseStatus.DeleteChildJobs_Failed;
+      }
+      return response;
+    }
+
     #endregion
 
@@ -420,6 +469,4 @@
 
 
-    
-
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/LifecycleManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/LifecycleManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/LifecycleManager.cs	(revision 4423)
@@ -28,51 +28,78 @@
 using System.Timers;
 using HeuristicLab.DataAccess.Interfaces;
+using HeuristicLab.Tracing;
+using System.Threading;
 
 namespace HeuristicLab.Hive.Server.Core {
-  class LifecycleManager: ILifecycleManager {
-    private static Timer timer =
-      new Timer();
+  class LifecycleManager : ILifecycleManager {
+    private AutoResetEvent waitHandle;
+    private Thread thread;
+    private bool shutdownRequested;
 
-    private static event EventHandler OnServerHeartbeat;
-    private static event EventHandler OnStartup;
-    private static event EventHandler OnShutdown;
+    private TimeSpan interval = new TimeSpan(0, 0, 10);
+    public TimeSpan Interval {
+      get { return interval; }
+      set { interval = value; }
+    }
+
+    private int jobsCurrentlyTransfering = 0;
+    public int JobsCurrentlyTransferring {
+      get { return jobsCurrentlyTransfering; }
+      set {
+        if (jobsCurrentlyTransfering != value) {
+          jobsCurrentlyTransfering = value;
+          Logger.Info("JobsCurrentlyTransfering: " + jobsCurrentlyTransfering);
+        }
+      }
+    }
 
     #region ILifecycleManager Members
 
-    public void RegisterHeartbeat(EventHandler handler) {
-      OnServerHeartbeat += handler;
-    }
-
-    public void RegisterStartup(EventHandler handler) {
-      OnStartup += handler;
-    }
-
-    public void RegisterShutdown(EventHandler handler) {
-      OnShutdown += handler;
-    }
-
-    public void Init() {
+    public void Start() {
+      Thread thread = new Thread(RunHeartbeatThread);
+      thread.Start();
       using (ServiceLocator.GetContextFactory().GetContext()) {
-        timer.Interval = new TimeSpan(0, 0, 10).TotalMilliseconds; // TODO: global constant needed
-        timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
-        timer.Start();
-
-        if (OnStartup != null)
-          OnStartup(this, null);
+        OnStarted();
       }
     }
 
-    void timer_Elapsed(object sender, ElapsedEventArgs e) {
+    private void RunHeartbeatThread() {
+      waitHandle = new AutoResetEvent(false);
+      shutdownRequested = false;
+      while (!shutdownRequested) {
+        using (ServiceLocator.GetContextFactory().GetContext(false)) {
+          OnServerHeartbeat();
+        }
+        waitHandle.WaitOne(this.Interval);
+      }
+      waitHandle.Close();
       using (ServiceLocator.GetContextFactory().GetContext()) {
-        if (OnServerHeartbeat != null)
-          OnServerHeartbeat(this, null);
+        OnStopped();
       }
     }
 
-    public void Shutdown() {
-      using (ServiceLocator.GetContextFactory().GetContext()) {
-        if (OnShutdown != null)
-          OnShutdown(this, null);
-      }
+    public void Stop() {
+      shutdownRequested = true;
+      if (waitHandle != null) waitHandle.Set();
+      if (thread != null) thread.Join();
+      thread = null;
+    }
+
+    public event EventHandler ServerHeartbeat;
+    private void OnServerHeartbeat() {
+      var handler = ServerHeartbeat;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler Started;
+    private void OnStarted() {
+      var handler = Started;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler Stopped;
+    private void OnStopped() {
+      var handler = Stopped;
+      if (handler != null) handler(this, EventArgs.Empty);
     }
 
